#!C:\Perl\bin\perl
use strict;
use warnings;
use CGI qw/:standard *table *tr *td/;

# 準備
my $cgi = new CGI;
my $cookie_key = 'testkey';
my $raw_cookie_from_client = $cgi->raw_cookie();
my $cookie_from_client = $cgi->cookie($cookie_key);
my $param_from_client = $cgi->param($cookie_key);
my $cookie_to_client;

# クライアントにクッキーを送信するかどうかの判断
if ($cgi->param('nowrite')) {
    $cookie_to_client = '';
} else {
    $cookie_to_client = $cgi->cookie(
        -name       => $cookie_key,
        -value      => $param_from_client,
        -expires    => '+30s', # 30秒で期限切れ
        # -path       => '/',
        # -domain     => '.example.com',
        # -secure     => 1,
    );
}

print $cgi->header(
    -charset => 'utf-8',
    -cookie => $cookie_to_client,
);

print $cgi->start_html(
    -title => 'Cookie Test',
    -style => { -src => 'style.css' },
);
print $cgi->h1('Cookie Test');

# サーバとクライアントとのやりとり
print $cgi->h2('このページを表示する際に…');
print $cgi->start_table({ -border => 1 });
print $cgi->TR(th('解説'), th('内容'));

# クライアントからのクッキー（全体）
print $cgi->start_TR();
print $cgi->td("サーバがクライアントから受信したクッキー全体");
print $cgi->td($raw_cookie_from_client);
print $cgi->end_TR();

# クライアントからのクッキー（個別）
print $cgi->start_TR();
print $cgi->td("サーバがクライアントから受信したクッキー($cookie_key)の値");
print $cgi->td($cookie_from_client);
print $cgi->end_TR();

# クライアントからのパラメータ
print $cgi->start_TR();
print $cgi->td('サーバがクライアントから受信したパラメータの値');
print $cgi->td($param_from_client);
print $cgi->end_TR();

# クライアントへのクッキー（全体）
print $cgi->start_TR();
print $cgi->td('サーバがクライアントへ送信したクッキー全体');
print $cgi->td($cookie_to_client);
print $cgi->end_TR();

print $cgi->end_table();

# サーバへパラメータを送信するためのフォーム
print $cgi->h2('サーバにパラメータを送信する');
print $cgi->start_form;
print $cgi->textfield(-name => $cookie_key, -value => $cookie_from_client);
print $cgi->submit('送信');
print $cgi->end_form;

# Webページをリロードするためのフォーム
print $cgi->h2('リロードする（パラメータは送信しない）');
print $cgi->start_form;
print $cgi->hidden(-name => 'nowrite', -value => 1);
print $cgi->submit('リロード');
print $cgi->end_form;

# 環境変数
print $cgi->h2('環境変数');
print $cgi->start_table({ -border => 1 });
print $cgi->TR(th('名前'), th('内容'));
print $cgi->end_TR();
foreach my $key (sort keys %ENV) {
    print $cgi->start_TR();
    print $cgi->td($key);
    print $cgi->td($ENV{$key});
    print $cgi->end_TR();
}
print $cgi->end_table;

print $cgi->end_html;
